# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Cosmosdb::Mgmt::V2020_06_01_preview
  module Models
    #
    # Parameters to create and update Cosmos DB database accounts.
    #
    class DatabaseAccountCreateUpdateParameters < ARMResourceProperties

      include MsRestAzure

      # @return [DatabaseAccountKind] Indicates the type of database account.
      # This can only be set at database account creation. Possible values
      # include: 'GlobalDocumentDB', 'MongoDB', 'Parse'. Default value:
      # 'GlobalDocumentDB' .
      attr_accessor :kind

      # @return [DatabaseAccountCreateUpdateProperties]
      attr_accessor :properties


      #
      # Mapper for DatabaseAccountCreateUpdateParameters class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'DatabaseAccountCreateUpdateParameters',
          type: {
            name: 'Composite',
            class_name: 'DatabaseAccountCreateUpdateParameters',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              location: {
                client_side_validation: true,
                required: false,
                serialized_name: 'location',
                type: {
                  name: 'String'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              identity: {
                client_side_validation: true,
                required: false,
                serialized_name: 'identity',
                type: {
                  name: 'Composite',
                  class_name: 'ManagedServiceIdentity'
                }
              },
              kind: {
                client_side_validation: true,
                required: false,
                serialized_name: 'kind',
                default_value: 'GlobalDocumentDB',
                type: {
                  name: 'String'
                }
              },
              properties: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties',
                default_value: {},
                type: {
                  name: 'Composite',
                  polymorphic_discriminator: 'createMode',
                  uber_parent: 'DatabaseAccountCreateUpdateProperties',
                  class_name: 'DatabaseAccountCreateUpdateProperties'
                }
              }
            }
          }
        }
      end
    end
  end
end
